FOLDER="models/gt_dialogue_moves_bootstrap_DlgMove_Graphs"
mkdir -p $FOLDER
CUDA_DEVICE=$1
SEED=$2

for MODEL in LSTM; do 
    for DLGM in Yes; do 
        for EXP in 6 7 8; do 

            DLG="No"
            POV="None"

            FILE_NAME="gt_dialogue_moves_${MODEL}_dlgMove_${DLGM}_dlg_${DLG}_pov_${POV}_exp${EXP}_seed_${SEED}"
            COMM="baselines_with_dialogue_moves_graphs.py"
            COMM=$COMM" --device=${CUDA_DEVICE}"
            COMM=$COMM" --seed=${SEED}"
            COMM=$COMM" --use_dialogue_moves=${DLGM}"
            COMM=$COMM" --use_dialogue=${DLG}"
            COMM=$COMM" --pov=${POV}"
            COMM=$COMM" --experiment=${EXP}"
            COMM=$COMM" --seq_model=${MODEL}"
            COMM=$COMM" --plan=Yes"
            COMM=$COMM" --save_path=${FOLDER}/${FILE_NAME}.torch"
            echo $(date +%F\ %T) $COMM" > ${FOLDER}/${FILE_NAME}.log"
            nice -n 5 python3 $COMM > ${FOLDER}/${FILE_NAME}.log

            DLG="Yes"
            POV="None"

            FILE_NAME="gt_dialogue_moves_${MODEL}_dlgMove_${DLGM}_dlg_${DLG}_pov_${POV}_exp${EXP}_seed_${SEED}"
            COMM="baselines_with_dialogue_moves_graphs.py"
            COMM=$COMM" --device=${CUDA_DEVICE}"
            COMM=$COMM" --seed=${SEED}"
            COMM=$COMM" --use_dialogue_moves=${DLGM}"
            COMM=$COMM" --use_dialogue=${DLG}"
            COMM=$COMM" --pov=${POV}"
            COMM=$COMM" --experiment=${EXP}"
            COMM=$COMM" --seq_model=${MODEL}"
            COMM=$COMM" --plan=Yes"
            COMM=$COMM" --model_path=${FOLDER}/gt_dialogue_moves_${MODEL}_dlgMove_${DLGM}_dlg_No_pov_None_exp${EXP}_seed_${SEED}.torch"
            COMM=$COMM" --save_path=${FOLDER}/${FILE_NAME}.torch"
            echo $(date +%F\ %T) $COMM" > ${FOLDER}/${FILE_NAME}.log"
            nice -n 5 python3 $COMM > ${FOLDER}/${FILE_NAME}.log

            DLG="No"
            POV="First"

            FILE_NAME="gt_dialogue_moves_${MODEL}_dlgMove_${DLGM}_dlg_${DLG}_pov_${POV}_exp${EXP}_seed_${SEED}"
            COMM="baselines_with_dialogue_moves_graphs.py"
            COMM=$COMM" --device=${CUDA_DEVICE}"
            COMM=$COMM" --seed=${SEED}"
            COMM=$COMM" --use_dialogue_moves=${DLGM}"
            COMM=$COMM" --use_dialogue=${DLG}"
            COMM=$COMM" --pov=${POV}"
            COMM=$COMM" --experiment=${EXP}"
            COMM=$COMM" --seq_model=${MODEL}"
            COMM=$COMM" --plan=Yes"
            COMM=$COMM" --model_path=${FOLDER}/gt_dialogue_moves_${MODEL}_dlgMove_${DLGM}_dlg_No_pov_None_exp${EXP}_seed_${SEED}.torch"
            COMM=$COMM" --save_path=${FOLDER}/${FILE_NAME}.torch"
            echo $(date +%F\ %T) $COMM" > ${FOLDER}/${FILE_NAME}.log"
            nice -n 5 python3 $COMM > ${FOLDER}/${FILE_NAME}.log

            DLG="Yes"
            POV="First"

            FILE_NAME="gt_dialogue_moves_${MODEL}_dlgMove_${DLGM}_dlg_${DLG}_pov_${POV}_exp${EXP}_seed_${SEED}_DlgFirst"
            COMM="baselines_with_dialogue_moves_graphs.py"
            COMM=$COMM" --device=${CUDA_DEVICE}"
            COMM=$COMM" --seed=${SEED}"
            COMM=$COMM" --use_dialogue_moves=${DLGM}"
            COMM=$COMM" --use_dialogue=${DLG}"
            COMM=$COMM" --pov=${POV}"
            COMM=$COMM" --experiment=${EXP}"
            COMM=$COMM" --seq_model=${MODEL}"
            COMM=$COMM" --plan=Yes"
            COMM=$COMM" --model_path=${FOLDER}/gt_dialogue_moves_${MODEL}_dlgMove_${DLGM}_dlg_Yes_pov_None_exp${EXP}_seed_${SEED}.torch"
            COMM=$COMM" --save_path=${FOLDER}/${FILE_NAME}.torch"
            echo $(date +%F\ %T) $COMM" > ${FOLDER}/${FILE_NAME}.log"
            nice -n 5 python3 $COMM > ${FOLDER}/${FILE_NAME}.log

            DLG="Yes"
            POV="First"

            FILE_NAME="gt_dialogue_moves_${MODEL}_dlgMove_${DLGM}_dlg_${DLG}_pov_${POV}_exp${EXP}_seed_${SEED}_VidFirst"
            COMM="baselines_with_dialogue_moves_graphs.py"
            COMM=$COMM" --device=${CUDA_DEVICE}"
            COMM=$COMM" --seed=${SEED}"
            COMM=$COMM" --use_dialogue_moves=${DLGM}"
            COMM=$COMM" --use_dialogue=${DLG}"
            COMM=$COMM" --pov=${POV}"
            COMM=$COMM" --experiment=${EXP}"
            COMM=$COMM" --seq_model=${MODEL}"
            COMM=$COMM" --plan=Yes"
            COMM=$COMM" --model_path=${FOLDER}/gt_dialogue_moves_${MODEL}_dlgMove_${DLGM}_dlg_No_pov_First_exp${EXP}_seed_${SEED}.torch"
            COMM=$COMM" --save_path=${FOLDER}/${FILE_NAME}.torch"
            echo $(date +%F\ %T) $COMM" > ${FOLDER}/${FILE_NAME}.log"
            nice -n 5 python3 $COMM > ${FOLDER}/${FILE_NAME}.log

        done
    done
done


echo "Done!"