echo Traning on int0!
CUDA_DEVICE=$1
DMOVE=$2
DLG=$3
LR=$4

echo $$ $CUDA_DEVICE $DMOVE $DLG

# FOLDER="models/incremental_pretrained_2_new"
# FOLDER="models/incremental_pretrained_2_new_fullsampling_ln"
# FOLDER="models/exp2"
# FOLDER="models/exp3"
FOLDER="models/exp2_int0exp2"
# FOLDER="models/exp2_test"
mkdir -p $FOLDER
for SEED in 7 42 123; do 
    for MODEL in Transformer; do 
        for EXP in 2; do # 2 3; do
            for INT in 0; do 
                FILE_NAME="plan_exp${EXP}_${MODEL}_dlg_${DLG}_move_${DMOVE}_int${INT}_seed_${SEED}"
                COMM="plan_predictor_graphs.py"
                COMM=$COMM" --seed=${SEED}"
                COMM=$COMM" --device=${CUDA_DEVICE}"
                COMM=$COMM" --use_dialogue_moves=${DMOVE}"
                COMM=$COMM" --use_dialogue=${DLG}"
                COMM=$COMM" --experiment=${EXP}"
                COMM=$COMM" --seq_model=${MODEL}"
                COMM=$COMM" --pov=First"
                COMM=$COMM" --plan=Yes"
                COMM=$COMM" --lr=${LR}"
                COMM=$COMM" --use_int0_instead_of_intermediate"
                COMM=$COMM" --intermediate=${INT}"
                if [ $INT -gt 0 ]; then
                    COMM=$COMM" --model_path=${FOLDER}/plan_exp${EXP}_${MODEL}_dlg_${DLG}_move_${DMOVE}_int0_seed_${SEED}.torch"
                fi
                COMM=$COMM" --save_path=${FOLDER}/${FILE_NAME}.torch"
                echo $(date +%F\ %T)" python3 ${COMM} > ${FOLDER}/${FILE_NAME}.log"
                nice -n 5 python3 $COMM > ${FOLDER}/${FILE_NAME}.log
            done
        done
    done
done

echo 'Done!'